/*
 * Product Ordering
 *
 * **TMF API Reference : TMF 622 - Product Ordering Management**  **Release : 19.0 - June 2019**  The Product Ordering API provides a standardized mechanism for placing a product order with all of the necessary order parameters. The API consists of a simple set of operations that interact with CRM/Order Negotiation systems in a consistent manner. A product order is created based on a product offer that is defined in a catalog. The product offer identifies the product or set of products that are available to a customer, and includes characteristics such as pricing, product options and market. This API provide a task based resource to request order cancellation.  The product order references the product offer and identifies any specific requests made by the customer.  **Product Order resource** A Product Order is a type of order which can be used to place an order between a customer and a service provider or between a service provider and a partner and vice versa. Main Product Order attributes are its identifier, state, priority category (mass market, Enterprise, etc.) related dates (start, completion, etc.), related billing account, related parties and order items. Main Order Items (aka order lines) attributes are the ordered offering and product characteristics with the related action to be performed (e.g. add or delete the products), state, location information for delivery, order item price and price alteration.  Product Order API performs the following operations on product order :     -Retrieval of a product order or a collection of product orders depending on filter criteria     -Partial update of a product order (including updating rules)    -Creation of a product order (including default values and creation rules)    -Deletion of product order (for administration purposes)     -Notification of events on product order.  **cancelProductOrder resource** This resource is used to request a product order cancellation. Product Order API performs the following operations on product order :     -Retrieval of a cancel product order or a collection of cancel product orders     -Creation of a cancel product order     -Notification of events on cancel product order.   Copyright © TM Forum 2019. All Rights Reserved   
 *
 * API version: 4.0.0
 */

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package openapi

import (
	"encoding/json"
)

// RelatedParty Related Entity reference. A related party defines party or party role linked to a specific entity.
type RelatedParty struct {
	// Unique identifier of a related entity.
	Id string `json:"id"`
	// Reference of the related entity.
	Href *string `json:"href,omitempty"`
	// Name of the related entity.
	Name *string `json:"name,omitempty"`
	// Role played by the related party
	Role *string `json:"role,omitempty"`
	// When sub-classing, this defines the super-class
	BaseType *string `json:"@baseType,omitempty"`
	// A URI to a JSON-Schema file that defines additional attributes and relationships
	SchemaLocation *string `json:"@schemaLocation,omitempty"`
	// When sub-classing, this defines the sub-class entity name
	Type *string `json:"@type,omitempty"`
	// The actual type of the target instance when needed for disambiguation.
	ReferredType string `json:"@referredType"`
}

// NewRelatedParty instantiates a new RelatedParty object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewRelatedParty(id string, referredType string, ) *RelatedParty {
	this := RelatedParty{}
	this.Id = id
	this.ReferredType = referredType
	return &this
}

// NewRelatedPartyWithDefaults instantiates a new RelatedParty object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewRelatedPartyWithDefaults() *RelatedParty {
	this := RelatedParty{}
	return &this
}

// GetId returns the Id field value
func (o *RelatedParty) GetId() string {
	if o == nil  {
		var ret string
		return ret
	}

	return o.Id
}

// GetIdOk returns a tuple with the Id field value
// and a boolean to check if the value has been set.
func (o *RelatedParty) GetIdOk() (*string, bool) {
	if o == nil  {
		return nil, false
	}
	return &o.Id, true
}

// SetId sets field value
func (o *RelatedParty) SetId(v string) {
	o.Id = v
}

// GetHref returns the Href field value if set, zero value otherwise.
func (o *RelatedParty) GetHref() string {
	if o == nil || o.Href == nil {
		var ret string
		return ret
	}
	return *o.Href
}

// GetHrefOk returns a tuple with the Href field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *RelatedParty) GetHrefOk() (*string, bool) {
	if o == nil || o.Href == nil {
		return nil, false
	}
	return o.Href, true
}

// HasHref returns a boolean if a field has been set.
func (o *RelatedParty) HasHref() bool {
	if o != nil && o.Href != nil {
		return true
	}

	return false
}

// SetHref gets a reference to the given string and assigns it to the Href field.
func (o *RelatedParty) SetHref(v string) {
	o.Href = &v
}

// GetName returns the Name field value if set, zero value otherwise.
func (o *RelatedParty) GetName() string {
	if o == nil || o.Name == nil {
		var ret string
		return ret
	}
	return *o.Name
}

// GetNameOk returns a tuple with the Name field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *RelatedParty) GetNameOk() (*string, bool) {
	if o == nil || o.Name == nil {
		return nil, false
	}
	return o.Name, true
}

// HasName returns a boolean if a field has been set.
func (o *RelatedParty) HasName() bool {
	if o != nil && o.Name != nil {
		return true
	}

	return false
}

// SetName gets a reference to the given string and assigns it to the Name field.
func (o *RelatedParty) SetName(v string) {
	o.Name = &v
}

// GetRole returns the Role field value if set, zero value otherwise.
func (o *RelatedParty) GetRole() string {
	if o == nil || o.Role == nil {
		var ret string
		return ret
	}
	return *o.Role
}

// GetRoleOk returns a tuple with the Role field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *RelatedParty) GetRoleOk() (*string, bool) {
	if o == nil || o.Role == nil {
		return nil, false
	}
	return o.Role, true
}

// HasRole returns a boolean if a field has been set.
func (o *RelatedParty) HasRole() bool {
	if o != nil && o.Role != nil {
		return true
	}

	return false
}

// SetRole gets a reference to the given string and assigns it to the Role field.
func (o *RelatedParty) SetRole(v string) {
	o.Role = &v
}

// GetBaseType returns the BaseType field value if set, zero value otherwise.
func (o *RelatedParty) GetBaseType() string {
	if o == nil || o.BaseType == nil {
		var ret string
		return ret
	}
	return *o.BaseType
}

// GetBaseTypeOk returns a tuple with the BaseType field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *RelatedParty) GetBaseTypeOk() (*string, bool) {
	if o == nil || o.BaseType == nil {
		return nil, false
	}
	return o.BaseType, true
}

// HasBaseType returns a boolean if a field has been set.
func (o *RelatedParty) HasBaseType() bool {
	if o != nil && o.BaseType != nil {
		return true
	}

	return false
}

// SetBaseType gets a reference to the given string and assigns it to the BaseType field.
func (o *RelatedParty) SetBaseType(v string) {
	o.BaseType = &v
}

// GetSchemaLocation returns the SchemaLocation field value if set, zero value otherwise.
func (o *RelatedParty) GetSchemaLocation() string {
	if o == nil || o.SchemaLocation == nil {
		var ret string
		return ret
	}
	return *o.SchemaLocation
}

// GetSchemaLocationOk returns a tuple with the SchemaLocation field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *RelatedParty) GetSchemaLocationOk() (*string, bool) {
	if o == nil || o.SchemaLocation == nil {
		return nil, false
	}
	return o.SchemaLocation, true
}

// HasSchemaLocation returns a boolean if a field has been set.
func (o *RelatedParty) HasSchemaLocation() bool {
	if o != nil && o.SchemaLocation != nil {
		return true
	}

	return false
}

// SetSchemaLocation gets a reference to the given string and assigns it to the SchemaLocation field.
func (o *RelatedParty) SetSchemaLocation(v string) {
	o.SchemaLocation = &v
}

// GetType returns the Type field value if set, zero value otherwise.
func (o *RelatedParty) GetType() string {
	if o == nil || o.Type == nil {
		var ret string
		return ret
	}
	return *o.Type
}

// GetTypeOk returns a tuple with the Type field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *RelatedParty) GetTypeOk() (*string, bool) {
	if o == nil || o.Type == nil {
		return nil, false
	}
	return o.Type, true
}

// HasType returns a boolean if a field has been set.
func (o *RelatedParty) HasType() bool {
	if o != nil && o.Type != nil {
		return true
	}

	return false
}

// SetType gets a reference to the given string and assigns it to the Type field.
func (o *RelatedParty) SetType(v string) {
	o.Type = &v
}

// GetReferredType returns the ReferredType field value
func (o *RelatedParty) GetReferredType() string {
	if o == nil  {
		var ret string
		return ret
	}

	return o.ReferredType
}

// GetReferredTypeOk returns a tuple with the ReferredType field value
// and a boolean to check if the value has been set.
func (o *RelatedParty) GetReferredTypeOk() (*string, bool) {
	if o == nil  {
		return nil, false
	}
	return &o.ReferredType, true
}

// SetReferredType sets field value
func (o *RelatedParty) SetReferredType(v string) {
	o.ReferredType = v
}

func (o RelatedParty) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if true {
		toSerialize["id"] = o.Id
	}
	if o.Href != nil {
		toSerialize["href"] = o.Href
	}
	if o.Name != nil {
		toSerialize["name"] = o.Name
	}
	if o.Role != nil {
		toSerialize["role"] = o.Role
	}
	if o.BaseType != nil {
		toSerialize["@baseType"] = o.BaseType
	}
	if o.SchemaLocation != nil {
		toSerialize["@schemaLocation"] = o.SchemaLocation
	}
	if o.Type != nil {
		toSerialize["@type"] = o.Type
	}
	if true {
		toSerialize["@referredType"] = o.ReferredType
	}
	return json.Marshal(toSerialize)
}

type NullableRelatedParty struct {
	value *RelatedParty
	isSet bool
}

func (v NullableRelatedParty) Get() *RelatedParty {
	return v.value
}

func (v *NullableRelatedParty) Set(val *RelatedParty) {
	v.value = val
	v.isSet = true
}

func (v NullableRelatedParty) IsSet() bool {
	return v.isSet
}

func (v *NullableRelatedParty) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableRelatedParty(val *RelatedParty) *NullableRelatedParty {
	return &NullableRelatedParty{value: val, isSet: true}
}

func (v NullableRelatedParty) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableRelatedParty) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


